
#property copyright " 2008-2011 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define vers   "1.0"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Beige
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1


extern int VPT_period = 9;
extern int VPT_applied_price = PRICE_CLOSE;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double VPTBuf[];

string short_name;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  IndicatorBuffers(1);
    
  SetIndexStyle(0, DRAW_LINE);
  SetIndexDrawBegin(0, 1);
  SetIndexBuffer(0, VPTBuf);
  SetIndexLabel(0, "VPT");
  SetIndexDrawBegin(0, VPT_period);

  short_name = "VolumePriceTrend("+VPT_period+")";
  IndicatorShortName(short_name);
}

void deinit()
{
}

int start() 
{  
  int counted_bars = IndicatorCounted();
  int limit = Bars - counted_bars;
  if (counted_bars > 0) limit++;

  for(int i = limit; i >= 0; i--)
  {
    double P0 = GetPrice(VPT_applied_price, i);
    double P1 = GetPrice(VPT_applied_price, i+VPT_period);
    
    if (i == Bars-1)
    {
      VPTBuf[i] = 0.0;
      continue;
    }
    
    if (P1 == 0.0)
    {
      VPTBuf[i] = VPTBuf[i+1];
      continue;
    }
    
    VPTBuf[i] = VPTBuf[i+1] + Volume[i]*(P0/P1 - 1.0);
  }
  
  return (0);
}

double GetPrice(int PriceType, int shift)
{
//----
  double res;
//----

  switch (PriceType)
  {
    case PRICE_OPEN:     
      res = Open[shift]; 
      break;
    
    case PRICE_HIGH:     
      res = High[shift]; 
      break;
      
    case PRICE_LOW:      
      res = Low[shift]; 
      break;
      
    case PRICE_MEDIAN:   
      res = (High[shift] + Low[shift]) / 2.0; 
      break;
      
    case PRICE_TYPICAL:  
      res = (High[shift] + Low[shift] + Close[shift])/3.0; 
      break;
      
    case PRICE_WEIGHTED: 
      res = (High[shift] + Low[shift] + 2*Close[shift]) / 4.0; 
      break;
      
    default:
      res = Close[shift]; 
      break;
  }

  return(res);
}

